diff --git a/system/config/routes.php b/system/config/routes.php
index 1b0926f..3dad6bf 100644
--- a/system/config/routes.php
+++ b/system/config/routes.php
@@ -34,8 +34,8 @@ Router::add('/_ajax/ticket_template/([0-9]+)', 'Misc::ticket_template/$1');
 Router::add('/_ajax/autocomplete/(username)', 'Misc::autocomplete_$1');
 
 // Attachment routes
-Router::add('/attachments/(?P<attachment_id>[0-9]+)/([a-zA-Z0-9\-_.]+)', 'Attachments::view/$1');
-Router::add('/attachments/(?P<attachment_id>[0-9]+)/([a-zA-Z0-9\-_.\s]+)/delete', 'Attachments::delete/$1');
+Router::add('/attachments/(?P<attachment_id>[0-9]+)/([^/]+)', 'Attachments::view/$1');
+Router::add('/attachments/(?P<attachment_id>[0-9]+)/([^/]+)/delete', 'Attachments::delete/$1');
 
 // ------------------------------------------------
 // Project routes
diff --git a/system/models/attachment.php b/system/models/attachment.php
index 0998ece..6badd35 100644
--- a/system/models/attachment.php
+++ b/system/models/attachment.php
@@ -50,7 +50,8 @@ class Attachment extends Model
 	 */
 	public function href($extra = '')
 	{
-		return "/attachments/{$this->id}/{$this->name}" . $extra;
+		$name_encoded = urlencode($this->name);
+		return "/attachments/{$this->id}/$name_encoded" . $extra;
 	}
 
 	public function is_valid()
